! ----- f90 -----

! ----- sTOFf: search for TOF fragments ----------------------------------------

! - parameters -----------------------------------------------------------------
!define USE_CAABA                 /* set if CAABA is used */
#define sTOFf_GC_isop_data        /* input also contains GC isoprene measurements */
#define sTOFf_output_fragment_yields /* include fragment yields in the output */
!define sTOFf_output_lab2gen_spectra /* include lab spectra integrated to generated masses in the output */
#define sTOFf_output_dot          /* produce diagram of compounds -> fragments -> masses links */
!define sTOFf_strange_sets        /* enable strange hit sets */

! - aMC parameters overrides ---------------------------------------------------
!undef  aMC_no_sim_on_master      /* master only serves run control & I/O */
!undef  aMC_output_non_real       /* output also uncuccessful realisations */
!undef  aMC_output_single_case    /* enable output containers for single cases */
!undef  aMC_output_common_set     /* enable output containers for sets of cases */
#undef  aMC_output_probe_stat     /* output MC probe statistic (use to check for skewed input) */
!undef  aMC_output_spare_extra_rq /* skip PE output requests if the local amnt. of hits is greater than ~ max_req / (#PEs) */
#undef  aMC_output_time_sort      /* sort output by time (@T-axis of netCDF, e.g. for ferret) */
#undef  aMC_output_time_gaps      /* add 1ms gaps to output (@T-axis of netCDF, e.g. for ferret) */
! - tuning/debugging -----------------------------------------------------------
!define aMC_run_single_sim        /* enable to run a single try simulation */
!define DEBUG                     /* useful runtime info */
!define DEEPDEBUG                 /* a lot of runtime info */

! ----- global imports ---------------------------------------------------------
#ifdef    aMC__uses
#endif /* aMC__uses */

! ----- global definitions -----------------------------------------------------
#ifdef    aMC__defs
 ! basic parameters
   real8, parameter       :: fatol = 0.5e-9,  &          !> fit tolerance: absolute (MR)  // largest selected
                             frtol =  2e-2,   &          !>                relative, also used for normalised spectra
                             hymass = 1.007277           !> hydron mass
 ! tech
   integer, parameter     :: fQ_max = 8                  !> max. no. of fragments expected in data file
   character(len=*), parameter &
                          :: fmt_smp = '(I4.4)', &       !> case/sample no. format
#ifndef DEBUG
                             fmt_au = '(f0.3)'           !> format to output masses in a.u.
#else
                             fmt_au = '(f8.3)'           !> format to output masses in a.u.
#endif
   character, parameter   :: fmt_sep = _tab_             !> separator for records in input data

 ! compound/fragment data
   type t_compound
     string               :: formula, name
     real8                :: m, mr, mr_maxprobe          !> mass, mixing ratio (+max. probed)
     integer              :: fQ                          !> no. of fragments
     real8, allocatable   :: fm(:),    &                 !> fragment mass
                             fy(:),    &                 !>          yield
                             fymin(:), &                 !>          yield: min
                             fymax(:)                    !>          yield: max
     integer, allocatable :: fsi(:)                      !>          index in spectrum
    end type t_compound

    type(t_compound), allocatable &
                          :: comp(:)                     !> compounds data
    integer               :: compQ                       !>           no. (plus unknown)


  ! spectra
    real8                 :: sTOFf_smrf = 1._dp/8000._dp !> spectrum mass resolution factor
  ! - generated
    integer               :: gsmQ                        !> qty of masses
    real8, allocatable    :: gsm(:),           &         !> generated spectrum masses
                             gsc(:,:), gscn(:,:)         !>   and counts (abs.+normalised) [1:gsmQ,1+smpQ] 0 slot for completely random, rest - for avail. lab data
    integer, allocatable  :: gsmsi(:)                    !> masses sorting index
  ! - lab
    integer               :: lsmQ                        !> qty of masses
    real8, allocatable    :: lsm(:), lsmm(:),  &         !> lab spectra masses + max. mass measured (to calculate transmission)
                             lst(:,:), lsc(:,:), &       !> transmission and counts [1:gsmQ,1+smpQ]
                             l2gsc(:,:),       &         !>                     re-integrated 2 generated spectra acc. for transmission
                             l2gscn(:,:),      &         !> + normalised
                             l2gsct(:,:)                 !> tolerance (max. of abs. vs rel.)
    integer, allocatable  :: l2gsmQ(:,:), &              !> qty/mask for masses being integrated/compared (there may be missing ones in lab data)
                             l2gsmQC(:)                  !> qty of masses being compared
  ! samples
    integer               :: smpQ                        !> no. of spectra samples
    character(len=255), allocatable &
                          :: lsid(:)                     !> sample ids
#ifdef sTOFf_GC_isop_data
    integer, parameter    :: idx_isop = 1                !> set isoprene compound index in input data here
    real8, allocatable    :: lGCisop(:), isop(:)         !> GC isoprene data, simulated (GC or random) isoprene
#endif
  ! corr. analysis
    real8, allocatable    :: corr(:,:)                   !> gen. vs. lab. spectra correlation pars. [k-b-R2+5interm,1:smpQ]
  ! extra diag/output
    real8, allocatable    :: lump_cm(:), lump_cmr(:), &  !> lumped mass and MR (from all compounds) [0:smpQ]
                             lump_fm(:), lump_fmr(:), &  !>                    (from all fragments)
                             nfm(:), nfmn(:)             !> no. of fitting masses (output), abs. + norm.
  ! hit sets/cases
    integer               :: sTOFf_set_abs,      &       !> all masses fit (absolute)
                             sTOFf_set_norm,     &       !> all masses fit (normalised)
#ifdef sTOFf_strange_sets
                             sTOFf_set_mv,       &       !> mass violation (created spurious mass)
                             sTOFf_set_abs_13p,  &       !> 13+ masses fit (absolute)
                             sTOFf_set_abs_14p,  &       !> 14+ masses fit (absolute)
                             sTOFf_set_abs_m2,   &       !> -2+ masses fit (absolute)
                             sTOFf_set_norm_m2,  &       !> -2+ masses fit (normalised)
                             sTOFf_set_corr,     &       !> correlation fit (R-based)
                             sTOFf_set_regr,     &       !> regression fit (slope-based)
#endif
                             sTOFf_set_abs_m1,   &       !> -1+ masses fit (absolute)
                             sTOFf_set_norm_m1,  &       !> -1+ masses fit (normalised)
                             sTOFf_set_hicorr,   &       !> high-correlation fit (slope+bias+R-based)
                             sTOFf_case_rand             !> case for random MRs+yields fitting (no lab data)
    integer, allocatable  :: sTOFf_case_smpi(:)          !> indices of aMC hit cases corresponding to samples
  ! unknown compounds
    integer               :: sTOFf_ucompQ = 0            !> no. of unknown compounds to add
    real8                 :: sTOFf_ucomp_mr_maxprobe     !>  & their max. probed MR [ppb]
#endif /* aMC__defs */


! ----- custom namelist entries ------------------------------------------------
#ifdef    aMC__nml
  sTOFf_smrf, &
  sTOFf_ucompQ, sTOFf_ucomp_mr_maxprobe, &
#endif /* aMC__nml */


! ----- custom routines --------------------------------------------------------
#ifdef    aMC__contains

! ----- read compound/fragment data for sTOFf -----
  subroutine sTOFf_read_comp_data(ifname)

    use, intrinsic  :: iso_fortran_env

    implicit none

    character(len=*), intent(in) :: ifname
    integer                      :: i, j, k, iou, rc
    string                       :: s, v
    character(len=2048)          :: sbuf
    real8                        :: rbuf(1:fQ_max*3), mpmr  !> mass + yield min/max, max. probed MR
    logical                      :: eof, eor

#ifndef DEBUG
    if ( p_parallel_io ) &
#endif
      _info_ 'sTOFf_read_comp_data(): reading from '//ifname

    iou = aMC_iou_find()
    open(unit=iou, file=trim(ifname), status='old')

  ! get the no. of records
    compQ = 0
    eof = .false.
    do while (.not.eof)
      i=0
      read(iou, '(a)', advance='no', iostat=rc, size=i) sbuf
      eof = IS_IOSTAT_END(rc)
      if ((.not.eof).and.(sbuf(1:1).ne.'#')) compQ = compQ + 1
    enddo
    close(iou)

#ifdef DEBUG
    print *,'sTOFf_compQ = '//num2str(i=compQ)
#endif

    allocate(comp(compQ))
    compQ = 0
    eof = .false.

  ! read the data
    open(unit=iou, file=trim(ifname), status='old')
    do while (.not.eof)
    ! read line
      read(iou, '(a)', advance='no', iostat=rc, size=i) sbuf
      eof = IS_IOSTAT_END(rc)
      eor = IS_IOSTAT_EOR(rc)

      if ((rc/=0).and.(.not.(eof.or.eor))) then
        print *, 'sTOFf_read_comp_data(): error reading "'//trim(ifname)//'", code: ', rc
        stop 101
      endif

    ! skip comments
      if (sbuf(1:1).eq.'#') cycle

    ! text in 1st col + numeric data
      s = str_field(sbuf(1:i),fmt_sep,1,notrim=.true.)
      v = sbuf(len(s)+2:i)

      if (.not.eof) then
      ! max. probed MR + fragment data
        read(v, *) mpmr, rbuf(1:fQ_max*3)
        compQ = compQ + 1
        comp(compQ)%formula = str_field(s,':',1)
        comp(compQ)%name    = str_field(s,':',2)
        comp(compQ)%mr_maxprobe = mpmr * 1e-9  !> in [ppb]
        comp(compQ)%fQ = 0
        s=''
        do i = 1, fQ_max
          j = (i-1)*3+1  !> current fragment column
          if ( rbuf(j) > 0. ) then
            comp(compQ)%fQ = comp(compQ)%fQ + 1
            k = comp(compQ)%fQ
            call resize(comp(compQ)%fm,k)
            call resize(comp(compQ)%fy,k)
            call resize(comp(compQ)%fymin,k)
            call resize(comp(compQ)%fymax,k)
            call resize(comp(compQ)%fsi,k)
            comp(compQ)%fm(k) = rbuf(j)
            comp(compQ)%fymin(k) = rbuf(j+1)/1e2
            comp(compQ)%fymax(k) = rbuf(j+2)/1e2
            comp(compQ)%fsi(k)   = 0
            s=s//' #'//num2str(k)//':'//num2str(r=comp(compQ)%fm(k),fmt=fmt_au) &
                                 //'/'//num2str(r=comp(compQ)%fymin(k),fmt=fmt_au) &
                                 //'-'//num2str(r=comp(compQ)%fymax(k),fmt=fmt_au)
          endif
        enddo

!! TODO: trick - compound mass assumed = that of the first fragment minus H+
        comp(compQ)%m = comp(compQ)%fm(1)-hymass
!! TODO

#ifndef DEBUG
        if ( p_parallel_io ) &
#endif
          _info_ ' comp.#'//num2str(compQ)//': ' &
                          //comp(compQ)%formula//' ('//comp(compQ)%name//') ' &
                          //num2str(r=comp(compQ)%m,fmt=fmt_au)//' a.u. | ' &
                          //num2str(comp(compQ)%fQ)//' fragments >'//s//' | ' &
                          //'max. probed MR: '//num2str(r=comp(compQ)%mr_maxprobe*1e9,fmt='(f0.1)')//' ppb'
      endif
    enddo
    close(iou)

#ifndef DEBUG
    if ( p_parallel_io ) &
#endif
      _info_ 'sTOFf_read_comp_data(): read '//num2str(compQ)//' compounds'

  end subroutine sTOFf_read_comp_data


! ----- figure out which masses can be generated out of fragments --------------
  subroutine sTOFf_isolate_gspectra_masses()

    implicit none

    integer  :: ci, fi, fq, gsi, ii, iou
    real8    :: mm
    logical  :: iapm, ex
    character(len=1024), allocatable :: lcmf(:)

  ! init
    fq = 0
    gsmQ = 0
    call resize(gsm,gsmQ)
    allocate(gsc(1:gsmQ,1))  !> so far one slot for purely random spectra

  ! lists of coincidental mass fragments
    allocate(lcmf(1:compQ*fQ_max))
    lcmf(:) = ''

  ! scanning all fragments, checking if they fall on already existing (within sTOFf_smrf) mass from other fragment(s)
    do ci = 1, compQ
      do fi = 1, comp(ci)%fQ
        fq = fq + 1            !> counting fragments
        mm = comp(ci)%fm(fi)   !> fragment mass
        iapm = .false.         !> flag for already present mass
      ! checking for the "same" mass already in spectrum
        do gsi = 1, gsmQ
          if (abs(mm-gsm(gsi)).le.(gsm(gsi)*sTOFf_smrf)) then
            comp(ci)%fsi(fi) = gsi    !> fragment index in spectrum
            gsc(gsi,1) = gsc(gsi,1) + 1.  !> count coincidence
            lcmf(gsi) = trim(lcmf(gsi))//' '//comp(ci)%formula//'#'//num2str(fi)
            iapm = .true.
          endif
        enddo
      ! new mass
        if ( .not.iapm ) then
          gsmQ = gsmQ + 1
          call resize(gsm,gsmQ)
          call resize(gsc,(/gsmQ,1/))
          gsm(gsmQ) = mm; gsc(gsmQ,1) = 1.
          comp(ci)%fsi(fi) = gsmQ  !> fragment index in spectrum
          lcmf(gsmQ) = comp(ci)%formula//'#'//num2str(fi)
        endif
      enddo
    enddo

  ! allocate normalised counts array
    allocate(gscn(1:gsmQ,1))
  ! lump masses & MRs (one slot for purely random)
    allocate(lump_cm(1))
    allocate(lump_cmr(1))
    allocate(lump_fm(1))
    allocate(lump_fmr(1))
    allocate(nfm(1))
    allocate(nfmn(1))

  ! masses sort index (for nicer output)
    call idxsort(gsm(:),gsmsi)
!!  sidx(:) = (/ (ii, ii=1,gsmQ,1) /)   ! no sorting (for debug)

  ! issue results
#ifdef DEBUG
    if ( .true. ) then
#else
    if ( p_parallel_io ) then
#endif
      _info_ 'sTOFf_isolate_gspectra_masses(): scanned '//num2str(fq)//' fragments, reckoned '//num2str(gsmQ)//' unique masses'
      _info_ ' no.'//_tab_//'mass'//_tab_//'#'//_tab_//'fragments'
      do gsi = 1, gsmQ
        _info_ ' '//num2str(gsi)//_tab_//num2str(r=gsm(gsmsi(gsi)),fmt=fmt_au)// &
                                  _tab_//num2str(int(gsc(gsmsi(gsi),1)))// &
                                  _tab_//trim(lcmf(gsmsi(gsi)))
      enddo
    endif

  ! cleanup
    deallocate(lcmf)

  end subroutine sTOFf_isolate_gspectra_masses


! ----- read lab spectra -----
  subroutine sTOFf_read_lab_data(ifname)

    use, intrinsic  :: iso_fortran_env

    implicit none

    character(len=*), intent(in) :: ifname
    real8                        :: oz, ap, hom
    integer                      :: i, j, k, iou, rc, rn
    string                       :: s, v, u
    character(len=32768)         :: sbuf
    logical                      :: eof, eor

#ifdef DEBUG
    print *,'sTOFf_read_lab_data(): reading from '//ifname
#endif

    iou = aMC_iou_find()
    open(unit=iou, file=trim(ifname), status='old')

  ! get the no. of records
#ifdef sTOFf_GC_isop_data
    lsmQ = -2  ! # of masses: we expect that there's also a column with GC isoprene data
#else
    lsmQ = -1  ! # of masses: we expect that there's a column with max. mass (for transmission calc.)
#endif
    smpQ = -1  ! # of samples: we expect that there's a header with masses
    eof = .false.
    do while (.not.eof)
      i=0
      read(iou, '(a)', advance='no', iostat=rc, size=i) sbuf
      eof = IS_IOSTAT_END(rc)
      if ((.not.eof).and.(sbuf(1:1).ne.'#')) smpQ = smpQ + 1
    ! header read, detecting no. of masses
      if (smpQ.eq.0) then
        do j = 1, i
          if (sbuf(j:j).eq.fmt_sep) lsmQ = lsmQ + 1  ! counting column separators
        enddo
      ! read masses
        call resize(lsm,lsmQ)
      ! id + max. mass columns
        s = str_field(sbuf(1:i),fmt_sep,1,notrim=.true.)//fmt_sep//str_field(sbuf(1:i),fmt_sep,2,notrim=.true.)
#ifdef sTOFf_GC_isop_data
      ! + GC isoprene column
        s = s//fmt_sep//str_field(sbuf(1:i),fmt_sep,3,notrim=.true.)
#endif
        v = sbuf(len(s)+2:i)
      ! convert values
#ifdef DEEPDEBUG
        print *,'sTOFf_read_lab_data(): s='//s
        print *,'sTOFf_read_lab_data(): trying to convert v='//v
#endif
        read(v, *) lsm(1:lsmQ)
      ! info
#ifndef DEBUG
        if ( p_parallel_io ) &
#endif
          _info_ 'sTOFf_read_lab_data(): expect '//num2str(lsmQ)//' masses spectra spanning ['// &
                 num2str(r=minval(lsm(:)),fmt=fmt_au)//'-'//num2str(r=maxval(lsm(:)),fmt=fmt_au)//']'
      endif
    enddo
    close(iou)

#ifdef DEBUG
    print *,'sTOFf: lsmQ = '//num2str(lsmQ)//', smpQ = '//num2str(smpQ)
    print '(A,*'//fmt_au//')', 'sTOFf: lsm = ', lsm(:)
#endif

  ! allocate arrays
    allocate(lsid(smpQ))              !> sample ids
    allocate(lsmm(smpQ))              !> max. mass measured for that sample (to calc. transmission)
    allocate(lst(lsmQ,smpQ))          !> transmission
    allocate(lsc(lsmQ,smpQ))          !> counts
    allocate(l2gsc(gsmQ,smpQ))        !> re-integrated 2 generated spectra
    allocate(l2gscn(gsmQ,smpQ))       !> + normalised
    allocate(l2gsct(gsmQ,smpQ))       !> tolerances
    allocate(l2gsmQ(gsmQ,smpQ))       !> count of lab masses integrated / flag for comparison (0 for none)
    allocate(l2gsmQC(smpQ))           !> qty of masses being compared
    allocate(sTOFf_case_smpi(1+smpQ)) !> indices of aMC hit cases corresponding to samples
    allocate(corr(1:3+5,smpQ))        !> gen. vs. lab. spectra correlation pars. [k-b-R2+5interm,1:smpQ]
  ! resize arrays to include sample-specific generated spectra
    call resize(gsc,(/gsmQ,1+smpQ/))  !> generated counts
    call resize(gscn,(/gsmQ,1+smpQ/)) !> + normalised
    call resize(lump_cm, 1+smpQ)      !> lumped mass and MR (all compounds/fragments)
    call resize(lump_cmr,1+smpQ)
    call resize(lump_fm, 1+smpQ)      !> lumped mass and MR (all fragments) with GC isoprene
    call resize(lump_fmr,1+smpQ)
    call resize(nfm,1+smpQ)           !> no. of fitting masses (abs.)
    call resize(nfmn,1+smpQ)          !> no. of fitting masses (norm.)
#ifdef sTOFf_GC_isop_data
    allocate(lGCisop(smpQ))           !> GC isoprene data
    allocate(isop(smpQ))              !> isoprene data ised in simulation
#endif

    u = ''  ! info str

  ! read the data
    eof = .false.
    open(unit=iou, file=trim(ifname), status='old')
    rn = -1                             ! -1 to skip the header
    do while (.not.eof)
    ! read line
      read(iou, '(a)', advance='no', iostat=rc, size=i) sbuf
      eof = IS_IOSTAT_END(rc)
      eor = IS_IOSTAT_EOR(rc)
      if ((rc/=0).and.(.not.(eof.or.eor))) then
        print *,'sTOFf_read_comp_data(): error reading "'//trim(ifname)//'", code: ', rc
        stop 101
      endif

      if (sbuf(1:1).eq.'#') cycle       ! skip comments

      rn = rn + 1                       ! advance record no.
      if (rn.lt.1) cycle

      if (.not.eof) then

      ! id in 1st col
        s = str_field(sbuf(1:i),fmt_sep,1,notrim=.true.)
        lsid(rn) = s
#ifdef sTOFf_GC_isop_data
      ! + GC isoprene data (2nd col)
        v = str_field(sbuf(1:i),fmt_sep,2,notrim=.true.)
        read(v,*) lGCisop(rn)
        s = s//fmt_sep//v
#endif
      ! + max. mass measured for given on that day (2/3 col)
        v = str_field(sbuf(1:i),fmt_sep,3,notrim=.true.)
        read(v,*) lsmm(rn)
        s = s//fmt_sep//v

      ! mass counts
        v = sbuf(len(s)+2:i)
        read(v,*) lsc(1:lsmQ,rn)

      ! checks if there are missing values (< 0)
        j = sum(merge(1,0,lsc(:,rn) .lt. 0.))
        if ( j.gt.0 ) u = u//' '//trim(lsid(rn))//'('//num2str(j)//')'

      endif
    enddo
    close(iou)

  ! convert pbb -> mol/mol
    lsc(:,:) = lsc(:,:) * 1e-9_dp
#ifdef sTOFf_GC_isop_data
#ifndef DEBUG
    if ( p_parallel_io ) &
#endif
      _info_ 'sTOFf_read_comp_data(): read GC isoprene data, missing: '//num2str(sum(merge(1,0,lGCisop(:) .lt. 0.)))// &
             ', span: ['//num2str(r=minval(merge(lGCisop(:),maxval(lGCisop(:)),lGCisop(:) .ge. 0.)),fmt='(f0.3)')// &
                        '-'//num2str(r=maxval(lGCisop(:)),fmt='(f0.3)')//'] ppb'
    lGCisop(:) = lGCisop(:) * 1e-9_dp
#endif

  ! calculate transmission for lab counts
    do j = 1, smpQ
      lst(:,j) = sqrt(lsm(:)/lsmm(j))
#ifdef DEEPDEBUG
      print *,'lst(:,'//num2str(j)//') =',lst(:,j)
#endif
    enddo

  ! info
#ifdef DEBUG
    if ( .true. ) then
#else
    if ( p_parallel_io ) then
#endif
      s = 'sTOFf_read_lab_data(): read '//num2str(smpQ)//' spectra'
      if ( u.ne.'' ) s = s//', of which with negative counts (assumed BD/missing):'//u
      _info_ s
    endif

#ifdef DEBUG
    print *,'sTOFf_read_lab_data(): finish'
#endif
  end subroutine sTOFf_read_lab_data


! ----- reintegrate lab spectra onto generated masses spectrum -----
  subroutine sTOFf_reintegrate_lspectra_masses()

    implicit none

    integer :: gsi, lsi, j
    string  :: s

#ifndef DEBUG
    if ( p_parallel_io ) &
#endif
      _info_ 'sTOFf_reintegrate_lspectra_masses(): <(range of compared masses qty.) labmass@transmissions-range> for comparison:'

  ! destination spectra
    l2gsc(:,:)  = 0.     !> re-integrated 2 generated spectra
    l2gscn(:,:) = 0.     !>   + (normalised)
    l2gsmQ(:,:) = 0      !> count of lab masses integrated (0 for none found)

    do gsi = 1, gsmQ
      s = ''
      do lsi = 1, lsmQ
        if ( abs(lsm(lsi)-gsm(gsi)) .le. (gsm(gsi)*sTOFf_smrf) ) then
          where ( lsc(lsi,:) .ge. 0._dp )                         !> negative counts mean missing data, skipping them
            l2gsc(gsi,:) = l2gsc(gsi,:) + lsc(lsi,:)/lst(lsi,:)   !> adjusting counts (up) for transmission
            l2gsmQ(gsi,:) = l2gsmQ(gsi,:) + 1
          endwhere
        ! info: add <labmass>@<transmissions-range>
          s = s//' '//num2str(r=lsm(lsi),fmt=fmt_au)//'@'// &
                      num2str(r=minval(lst(lsi,:)),fmt='(F0.3)')//'-'// &
                      num2str(r=maxval(lst(lsi,:)),fmt='(F0.3)')
        endif
      enddo
#ifndef DEBUG
      if ( p_parallel_io ) &
#endif
      ! info: det. mass <- (range of compared masses qty.) + info on mass@trans
        _info_ ' '//num2str(r=gsm(gsi),fmt=fmt_au)//' <- ('// &
                    num2str(minval(l2gsmQ(gsi,:)))//'-'// &
                    num2str(maxval(l2gsmQ(gsi,:)))//')'//s
    enddo

    do j = 1, smpQ
    ! normalised spectra
      if ( sum(l2gsc(:,j)) .gt. 0. ) l2gscn(:,j) = l2gsc(:,j)/maxval(l2gsc(:,j))
    ! abs. tolerances are for abs. counts -> adjusted for transmission
      l2gsct(:,j) = max(fatol,l2gsc(:,j)*frtol)        !! TODO: adj. tolerance by transmission -> do not use /lst(:,j) ! => ast to be recalc. for gen.spectra/sample
#ifdef DEEPDEBUG
      print *,'l2gsct(:,'//num2str(j)//') =',l2gsct(:,j)
#endif
    ! number of masses being compared
      l2gsmQC(j) = sum(merge(1,0,l2gsmQ(:,j).gt.0))
    enddo

  ! making not compared masses negative (they will not count as match even compared to zero)
    where ( l2gsmQ(:,:) .eq. 0 )
      l2gsc(:,:) = -1.
      l2gscn(:,:) = -1.
    endwhere

#ifndef DEBUG
    if ( p_parallel_io ) &
#endif
      _info_ 'sTOFf_reintegrate_lspectra_masses(): done, qty. of masses being compared: '//&
             num2str(minval(l2gsmQC(:)))//'-'//num2str(maxval(l2gsmQC(:)))

  end subroutine sTOFf_reintegrate_lspectra_masses


! ----- add unknown compounds -----
  subroutine sTOFf_add_unknown_comp(qty, mpmr)

    implicit none

    integer, intent(in) :: qty                     !> qty of compounds
    real8, intent(in)   :: mpmr                    !> max. probed MR
    integer             :: uci, fi, gsi
    string              :: s, v
    type(t_compound), allocatable :: tmp(:)

#ifndef DEBUG
    if ( p_parallel_io ) &
#endif
      _info_ 'sTOFf_add_unknown_comp(): adding '//num2str(qty)//' unknown compounds'

    if (qty.lt.1) return

  ! resizing compounds data
    allocate(tmp(compQ)); tmp(:) = comp(:)
    deallocate(comp); allocate(comp(compQ+qty))
    comp(1:compQ) = tmp(:); deallocate(tmp)

  ! adding one by one
    do uci = 1, qty

      compQ = compQ + 1
      comp(compQ)%formula = 'UC'//num2str(compQ)
      comp(compQ)%name = 'unknown-'//num2str(compQ)
      comp(compQ)%mr_maxprobe = mpmr
      comp(compQ)%fQ = 0

#ifdef DEBUG
    print *,'sTOFf_compQ = '//num2str(i=compQ)
#endif

      s=''
    ! adding fragments
      do gsi = 1, gsmQ
        if ( sum(l2gsmQ(gsi,:)).gt.0 ) then ! only if there's any lab data on that mass
          comp(compQ)%fQ = comp(compQ)%fQ + 1
          fi = comp(compQ)%fQ
        ! allocate
          call resize(comp(compQ)%fm,fi)
          call resize(comp(compQ)%fy,fi)
          call resize(comp(compQ)%fymin,fi)
          call resize(comp(compQ)%fymax,fi)
          call resize(comp(compQ)%fsi,fi)
        ! fill data
          comp(compQ)%fm(fi)    = gsm(gsi)
          comp(compQ)%fymin(fi) = 0. ! TODO : define using optional parameter?
          comp(compQ)%fymax(fi) = 1. !
          comp(compQ)%fsi(fi)   = gsi
          s=s//' #'//num2str(fi)//':'//num2str(r=comp(compQ)%fm(fi),fmt=fmt_au) &
                                //'/'//num2str(r=comp(compQ)%fymin(fi),fmt=fmt_au) &
                                //'-'//num2str(r=comp(compQ)%fymax(fi),fmt=fmt_au)
        endif
      enddo

#ifndef DEBUG
        if ( p_parallel_io ) &
#endif
       _info_ ' comp.#'//num2str(compQ)//': ' &
                       //comp(compQ)%formula//' ('//comp(compQ)%name//') ' &
                       //num2str(r=comp(compQ)%m,fmt=fmt_au)//' a.u. | ' &
                       //num2str(comp(compQ)%fQ)//' fragments >'//s//' | ' &
                       //'max. probed MR: '//num2str(r=comp(compQ)%mr_maxprobe*1e9,fmt='(f0.1)')//' ppb'
    enddo

  end subroutine sTOFf_add_unknown_comp


! ----- produce a .dot diagram of compound-fragment-mass relationship -----
  subroutine sTOFf_produce_dot()

    implicit none
    integer             :: gsi, ci, fi, iou
    string              :: s, q, v
    character(len=1024) :: rs(0:fQ_max)  ! rank=same specif. for fragments

    iou = aMC_iou_find()
    open(unit=iou, file='sTOFf.dot', status='replace')

  ! digraph open
    write(iou,*) 'digraph sTOFf {'//_cr_
    write(iou,*) '  rankdir = LR; splines=true; overlap=false; normalize=true; // concentrate=true;'//_cr_
    write(iou,*) '  node [fontname="Miso", fontsize=40, shape=ellipse, style="bold,filled"];'
    write(iou,*) '  edge [fontname="Miso", fontsize=40, style=bold, arrowhead=normal, arrowsize=2];'
    write(iou,*) '  graph [style=filled, color=lightgrey];'

!  CH4 [ label="CH4",  shape=diamond, color=orange4, fillcolor=orange fontcolor=black ];
!  G12xx -> G12xx [label="(oxygen)", color=firebrick, fontcolor=firebrick];
!  { rank=max; G12xx G3xxx G41xx G4xxx G6xxx G7xxx G8xxx G9xxx Jxxxx AVEx LOSSx intermediate source }

    s = ''
    do gsi = 1, gsmQ
      q = num2str(r=gsm(gsi),fmt=fmt_au)
    ! mass
      write(iou,*) '  gsm_'//num2str(gsi)//' [ label="'//q//'", shape=triangle, fillcolor=salmon ];'
      s = s//' gsm_'//num2str(gsi)
    enddo
    write(iou,*) '  { rank=same; fgsm '//trim(s)//' }'//_cr_

    rs(:) = ''

    do ci = 1, compQ
    ! fragment
      q = comp(ci)%formula
      write(iou,*) '  subgraph cluster_'//num2str(ci)//' {'
      write(iou,*) '    '//q//' [ label="'//comp(ci)%name//'", fillcolor=cornflowerblue ];'
      rs(0) = trim(rs(0))//' '//q
      v = ''
      do fi = 1, comp(ci)%fQ
        s=num2str(fi)
      ! fragment
        write(iou,*) '    '//q//'_f'//s//' [ label="F'//s//'\n('//num2str(int(comp(ci)%fymin(fi)*1e2)) &
                                                  //'-'//num2str(int(comp(ci)%fymax(fi)*1e2))//')%", shape=diamond, fillcolor=darkkhaki ];'
      ! comp -> fragment
        write(iou,*) '    '//q//' -> '//q//'_f'//s//' [ label="" ];'
      ! fragment-> mass
        write(iou,*) '    '//q//'_f'//s//' -> gsm_'//num2str(comp(ci)%fsi(fi))//' [ label="", penwidth='//num2str(r=comp(ci)%fymax(fi)*10.)//' ];'
      ! add to fragment rank
        rs(fi) = trim(rs(fi))//' '//q//'_f'//s
      ! fragment -> fragment
        if ( fi.gt.1 ) v = v//' -> '
        v = v//q//'_f'//s
      enddo
      write(iou,*) '   '//v//' [style=invis];'
      write(iou,*) '  }'//_cr_
    enddo

    s = ''
    do fi = 0, fQ_max
      if (trim(rs(fi)).ne.'') then
        s=s//'f'//num2str(fi)//' -> '
        write(iou,*) '  { rank=same; f'//num2str(fi)//' '//trim(rs(fi))//' };'
      endif
    enddo
    write(iou,*) '  { '//s//' fs -> fgsm [style=invis]; };'//_cr_

  ! digraph close
    write(iou,*) _cr_//'}'
    close(iou)

    _info_ 'sTOFf_produce_dot(): done'

  end subroutine sTOFf_produce_dot


#endif /* aMC__contains */

! ----- custom [de]init --------------------------------------------------------
#ifdef    aMC__init__defs
#endif /* aMC__init__defs */
#ifdef    aMC__init__code

#ifndef DEBUG
    if ( p_parallel_io ) &
#endif
      _info_ _cr_//'sTOFf: init. start'
    call sTOFf_read_comp_data('fragments.dat')
    call sTOFf_isolate_gspectra_masses()
    call sTOFf_read_lab_data('spectra.dat')
    call sTOFf_reintegrate_lspectra_masses()
    if ( sTOFf_ucompQ .gt. 0 ) &
      call sTOFf_add_unknown_comp(sTOFf_ucompQ, sTOFf_ucomp_mr_maxprobe*1e-9) ! in [pbb]
#ifdef sTOFf_output_dot
    if ( p_parallel_io .and. (.not.aMC_restart) ) call sTOFf_produce_dot()
#endif
#ifndef DEBUG
    if ( p_parallel_io ) &
#endif
      _info_ 'sTOFf: init. done'//_cr_

  ! swtich on only common probestat output
    aMC_hit_set(aMC_hit_set_probestat)%out_single = .false.
    aMC_hit_set(aMC_hit_set_probestat)%out_common = .true.

#endif /* aMC__init__code */

#ifdef    aMC__deinit__defs
  ! already defined: exitcode, i, j
#endif /* aMC__deinit__defs */
#ifdef    aMC__deinit__code
  ! deallocate all data
  ! compounds
    do i = 1, compQ
      deallocate(comp(i)%fm)    !> fragment mass
      deallocate(comp(i)%fy)    !>          yield
      deallocate(comp(i)%fymin) !>          yield: min
      deallocate(comp(i)%fymax) !>          yield: max
      deallocate(comp(i)%fsi)   !>          index in spectrum
    enddo
    deallocate(comp)            !> compounds data
  ! spectra
  ! generated
    deallocate(gsm)             !> masses
    deallocate(gsmsi)           !> + sort index
    deallocate(gsc)             !> counts
    deallocate(gscn)            !> + normalised
    deallocate(lump_cm)
    deallocate(lump_cmr)
    deallocate(lump_fm)
    deallocate(lump_fmr)
    deallocate(nfm)             !> no. of fitting masses
    deallocate(nfmn)            !> no. of fitting masses
  ! lab
    deallocate(lsid)            !> sample ids
    deallocate(lsmm)            !> max. mass measured for that sample (to calc. transmission)
    deallocate(lst)             !> transmission
    deallocate(lsm)             !> masses
    deallocate(lsc)             !> counts
    deallocate(l2gsc)           !> re-integrated to generated spectra
    deallocate(l2gscn)          !> + normalised
    deallocate(l2gsct)          !> tolerances
    deallocate(l2gsmQ)          !> count/mask of lab masses integrated/to be compaerd (0 for none)
    deallocate(l2gsmQC)         !> qty of masses being compared
    deallocate(sTOFf_case_smpi) !> indices of aMC hit cases corresponding to samples
    deallocate(corr)            !> gen. vs. lab. spectra correlation pars. [k-b-R2+5interm,1:smpQ]
#ifdef sTOFf_GC_isop_data
    deallocate(lGCisop)         !> GC isoprene data
    deallocate(isop)            !> simulated isoprene data
#endif
#endif /* aMC__deinit__code */

! ----- MC parameter setup -----------------------------------------------------
#ifdef    aMC__parameter_setup__defs
  ! already defined vars: res, ci
    integer :: fi
    string  :: sf, sn
    logical :: lout
#endif /* aMC__parameter_setup__defs */
#ifdef    aMC__parameter_setup__code
  ! MC parameters
    do ci = 1, compQ
    ! compound mixing ratio
      sn = comp(ci)%name
      sf = comp(ci)%formula
      lout = .true.
#ifdef sTOFf_GC_isop_data
    ! adding output lab GC isoprene (where available, otherwise rand), switch off output of the actual random probed
      if ( ci .eq. idx_isop) then
        res = aMC_output_add(sf//' | ppb | '//sn//' (lab or random)', ra=isop, sf=1e9_dp)
        lout = .false.
      endif
#endif
      res = aMC_mcpar_register(aMC_kind_unif, r=comp(ci)%mr, range=(/ 0., real(comp(ci)%mr_maxprobe) /), &
                               info=sf//' | ppb | '//sn, sf=1e9_dp, out=lout )
    ! probe yields for probed compounds only
      if ( comp(ci)%mr_maxprobe .le. 0. ) cycle
    ! compound fragments yields
      do fi = 1, comp(ci)%fQ
        res = aMC_mcpar_register(aMC_kind_unif, r=comp(ci)%fy(fi), range=real((/ comp(ci)%fymin(fi), comp(ci)%fymax(fi) /)), sf=1e2_dp, &
                                 info=sf//'_yf'//num2str(fi)//' | percent | '//sf//' fragment #'//num2str(fi)//' (mass '//num2str(r=comp(ci)%fm(fi),fmt=fmt_au)//') yield', &
#ifdef sTOFf_output_fragment_yields
                                 out=.true. )
#else
                                 out=.false. )
#endif
      enddo
    enddo

  ! output
  ! spectra, only comparable ones
  ! generated
    do ci = 1, gsmQ
      if ( maxval(l2gsmQ(gsmsi(ci),:)) .gt. 0 ) then
        sf = num2str(r=gsm(gsmsi(ci)),fmt=fmt_au)
        res = aMC_output_add('gsc_'//num2str(ci,fmt='(I2.2)')//' | ppb | mass '//sf//' generated MR', ra=gsc(gsmsi(ci),:), sf=1e9_dp)
      endif
    enddo
#ifdef sTOFf_output_lab2gen_spectra
  ! lab spectra
    do ci = 1, gsmQ
      if ( ( maxval(l2gsmQ(gsmsi(ci),:)) .gt. 0 ) .and.  ) then
        sf = num2str(r=gsm(gsmsi(ci)),fmt=fmt_au)
        res = aMC_output_add('l2gsc_'//num2str(ci,fmt='(I2.2)')//' | ppb | mass '//sf//' lab integrated MR', ra=l2gsc(gsmsi(ci),:), sf=1e9_dp)
      endif
    enddo
#endif
  ! lumped mass and MR for educts and fragments
    res = aMC_output_add('lump_cm  | a.u. | lumped mass (all compounds)', ra=lump_cm)
    res = aMC_output_add('lump_cmr | ppb  | lumped MR (all compounds)',   ra=lump_cmr, sf=1e9_dp)
    res = aMC_output_add('lump_fm  | a.u. | lumped mass (all fragments)', ra=lump_fm)
    res = aMC_output_add('lump_fmr | ppb  | lumped MR (all fragments)',   ra=lump_fmr, sf=1e9_dp)
  ! correlation analysis
    res = aMC_output_add('corr_k   | ppb/ppb | corr. slope (gen. vs. lab spectra masses)', ra=corr(1,:))
    res = aMC_output_add('corr_b   | ppb     | corr. bias (gen. vs. lab spectra masses)',  ra=corr(2,:), sf=1e9_dp)
    res = aMC_output_add('corr_r   | -1+1    | corr. coeff. det. (gen. vs. lab spectra masses)', ra=corr(3,:))
  ! no. of fitting masses
    res = aMC_output_add('nfm      | count   | no. of fitting masses (gen. vs. lab spectra)', ra=nfm(:))
    res = aMC_output_add('nfmn     | count   | no. of fitting masses (gen. vs. lab spectra, normalised)', ra=nfmn(:))

  ! hit sets/cases
    sTOFf_set_abs       = aMC_hit_set_add('abs     | all masses fit (absolute)',              out_single=.true.  )
    sTOFf_set_abs_m1    = aMC_hit_set_add('abs_m1  | all-1 mass fit (absolute)',              out_single=.true.  )
    sTOFf_set_norm      = aMC_hit_set_add('norm    | all masses fit (normalised)',            out_single=.false. )
    sTOFf_set_norm_m1   = aMC_hit_set_add('norm_m1 | all-1 mass fit (normalised)',            out_single=.false. )
    sTOFf_set_hicorr    = aMC_hit_set_add('hicorr  | high correlation fit (k=1+-0.05,b=0+-0.05,R>0.9)', out_single=.false. )
#ifdef sTOFf_strange_sets
    sTOFf_set_mv        = aMC_hit_set_add('mv      | mass violation (created spurious mass)', out_single=.false. )
    sTOFf_set_abs_13p   = aMC_hit_set_add('abs_13p | 13+ masses fit (absolute)',              out_single=.false. )
    sTOFf_set_abs_14p   = aMC_hit_set_add('abs_14p | 14+ masses fit (absolute)',              out_single=.false. )
    sTOFf_set_abs_m2    = aMC_hit_set_add('abs_m2  | all -2 masses fit (absolute)',           out_single=.false. )
    sTOFf_set_norm_m2   = aMC_hit_set_add('norm_m2 | all -2 masses fit (normalised)',         out_single=.false. )
    sTOFf_set_corr      = aMC_hit_set_add('corr    | correlation fit (R^2 > 0.95)',           out_single=.false. )
    sTOFf_set_regr      = aMC_hit_set_add('regr    | slope regression fit (k=1+-0.05)',       out_single=.false. )
#endif

  ! cases as lab samples
    do ci = 1, smpQ
      sf = num2str(ci,fmt=fmt_smp)
      sn = sf//' | sample id:'//trim(lsid(ci))//', # of compared masses:'//num2str(l2gsmQC(ci))
#ifdef sTOFf_GC_isop_data
      sn = sn//', GC isoprene MR:'//num2str(r=lGCisop(ci)*1e9,fmt='(f0.3)')//' ppb'
#endif
      res = aMC_hit_case_add(sn)
      sTOFf_case_smpi(res) = ci
    enddo
  ! purely random case
    sTOFf_case_rand = aMC_hit_case_add(' rand | purely random MRs & yields / spectra gen. diag., # of masses:'//num2str(gsmQ))
    sTOFf_case_smpi(sTOFf_case_rand) = smpQ+1
#endif /* aMC__parameter_setup__code */

! ----- new initial state ------------------------------------------------------
#ifdef    aMC__new_x0__defs
    integer :: ci, fi
    real8   :: ysum
#endif /* aMC__new_x0__defs */
#ifdef    aMC__new_x0__code
  ! fit unknown compounds' yields to 100%
    if ( sTOFf_ucompQ .gt. 0 ) then
      do ci = compQ-sTOFf_ucompQ+1, compQ
        ysum = sum(comp(ci)%fy(1:comp(ci)%fQ))
        comp(ci)%fy(:) = comp(ci)%fy(:) / ysum
      enddo
    endif
#endif /* aMC__new_x0__code */

! ----- prepare output ---------------------------------------------------------
#ifdef    aMC__output_prepare__defs
#endif /* aMC__output_prepare__defs */
#ifdef    aMC__output_prepare__code
    ! pushing aMC_NODATA for missing/not compared lab spectra masses
!     where ( l2gsc(:,:) .lt. 0._dp ) l2gsc(:,:) = aMC_NODATA
#endif /* aMC__output_prepare__code */

! ----- find matching cases ----------------------------------------------------
#ifdef    aMC__match__defs
      integer :: smpi       ! sample index
      logical :: is_mv      ! mass violation flag
#endif /* aMC__match__defs */
! inside the loop over cases: case = aMC_match_case_from, aMC_match_case_upto
! NOTE: do not use cycle!
#ifdef    aMC__match__cases__code

      smpi = sTOFf_case_smpi(case)  ! indices for lab samples + random

#ifdef DEBUG
      print *,'--- comparing case: '//aMC_hit_case(case)%name,' smpi:',smpi,'-------'
      print *, 'lump fmr / fm:',lump_fmr(smpi), lump_fm(smpi)
      print '(A,*(f9.4))', 'gen.cnt.:',gsc(:,smpi)*1e9
      print '(A,*(f9.4))', '(%norm.):',gscn(:,smpi)*1e2
#endif

    ! probe statistic
      aMC_hit_set(aMC_hit_set_probestat)%is_hit = .true.

    ! mass violation: lump fragments mass > lump compounds mass
      is_mv = ( lump_fm(smpi) .gt. lump_cm(smpi) )
!!    aMC_hit_set(sTOFf_set_mv)%is_hit = ( lump_fm(smpi) .gt. lump_cm(smpi) )

    ! further checks for cases that correspond to lab samples
      if ( ( smpi.ge.1 ) .and. ( smpi.le.smpQ ) .and. ( .not.is_mv ) ) then

      ! no. of fitting masses (within tolerance l2gsct), not compared masses are set negative and never count as a match
!       nfm  = sum(merge(1,0,dabs(  l2gsc(:,smpi)- gsc(:,smpi)).lt.       l2gsct(:,smpi)))
        nfm(smpi)  = sum(merge(1,0,dabs(  l2gsc(:,smpi)- gsc(:,smpi)) .lt. l2gsct(:,smpi)))   !aMC_check_pairs( gsmQ, (/ gsc(:,smpi),  l2gsc(:,smpi),  l2gsct(:,smpi)       /) )
        nfmn(smpi) = sum(merge(1,0,dabs( l2gscn(:,smpi)-gscn(:,smpi)) .lt. frtol         ))   !aMC_check_pairs( gsmQ, (/ gscn(:,smpi), l2gscn(:,smpi), frtol*l2gscn(:,smpi) /) )  !! TODO: define own tolerance for normalised counts
#ifdef DEBUG
        print '(A,*(i9))',   '  l2gsmQ:',l2gsmQ(:,smpi)
        print '(A,*(f9.4))', 'l2g tol.:',l2gsct(:,smpi)*1e9
        print *,             ' l2gsmQC:',l2gsmQC(smpi)
        print '(A,*(f9.4))', 'l2g cnt.:',l2gsc(:,smpi)*1e9
        print '(A,*(f9.4))', '(%norm.):',l2gscn(:,smpi)*1e2
        print *,'lab lump fmr / mr:',sum(merge(l2gsc(:,smpi),0._dp,l2gsc(:,smpi).gt.0)),dot_product(merge(l2gsc(:,smpi),0._dp,l2gsc(:,smpi).gt.0),gsm(:))
        print *,'corr (k,b,r):',corr(1:3,smpi)
        print '(A,'//num2str(gsmQ)//'(l9)(i4))', ' chk/nfm:',dabs(  l2gsc(:,smpi)- gsc(:,smpi)) .lt. l2gsct(:,smpi), nfm
        print '(A,'//num2str(gsmQ)//'(l9)(i4))', 'chk/nfmn:',dabs( l2gscn(:,smpi)-gscn(:,smpi)) .lt. frtol         , nfmn
#endif

      ! full spectrum fit (abs. counts)
        aMC_hit_set(sTOFf_set_abs)%is_hit     = nfm(smpi).ge.l2gsmQC(smpi)
        aMC_hit_set(sTOFf_set_abs_m1)%is_hit  = (nfm(smpi).ge.(l2gsmQC(smpi)-1)) .and. (dabs(corr(1,smpi)-1.0_dp) .lt. 0.1_dp)

      ! normalised
        aMC_hit_set(sTOFf_set_norm)%is_hit    = nfmn(smpi).ge.(l2gsmQC(smpi))
        aMC_hit_set(sTOFf_set_norm_m1)%is_hit = nfmn(smpi).ge.(l2gsmQC(smpi)-1)

      ! high-correlated
        aMC_hit_set(sTOFf_set_hicorr)%is_hit = ( dabs(corr(1,smpi)-1._dp) .lt. 0.05_dp ) .and.        & ! slope
                                               ( dabs(corr(2,smpi)) .lt. ( 0.05_dp * 1e-9_dp) ) .and. & ! bias
                                               (     (corr(3,smpi)) .gt. 0.9_dp )                       ! R
#ifdef sTOFf_strange_sets
      ! correlated/regressed
        aMC_hit_set(sTOFf_set_corr)%is_hit = (corr(3,smpi)*2) .gt. 0.9_dp          ! R>0.9
        aMC_hit_set(sTOFf_set_regr)%is_hit = dabs(1._dp-corr(1,smpi)) .lt. 0.05_dp ! slope

!       aMC_hit_set(sTOFf_set_abs_13p)%is_hit = nfm(smpi).ge.13
!       aMC_hit_set(sTOFf_set_abs_14p)%is_hit = nfm(smpi).ge.14
!       aMC_hit_set(sTOFf_set_abs_m2)%is_hit  = nfm(smpi).ge.(l2gsmQC(smpi)-2)
!       aMC_hit_set(sTOFf_set_norm_m2)%is_hit = nfmn(smpi).ge.(l2gsmQC(smpi)-2)
#endif
      endif ! lab-related samples

#endif /* aMC__match__cases__code */

! ----- aMC_physc --------------------------------------------------------------
#ifdef    aMC__physc__defs
     integer :: mi, fi, si
#endif /* aMC__physc__defs */
#ifdef    aMC__physc__code

   ! compute generated spectrum and lumped masses/MRs
     gsc(:,:) = 0.
     lump_cmr(:) = 0.
     lump_cm(:)  = 0.
     lump_fmr(:) = 0.
     lump_fm(:)  = 0.

   ! compound-wise
     do ci = 1, compQ
!!     do fi = 1, comp(ci)%fQ
!!       gsc(comp(ci)%fsi(fi)) = gsc(comp(ci)%fsi(fi)) + comp(ci)%mr*comp(ci)%fy(fi)
!!     enddo
     ! adding fragments' inputs
     ! pure random
       gsc(comp(ci)%fsi(:),sTOFf_case_rand) = gsc(comp(ci)%fsi(:),sTOFf_case_rand) &
                                              + comp(ci)%mr*comp(ci)%fy(:)
#ifdef sTOFf_GC_isop_data
     ! calculating spectra for samples with GC isoprene MRs

     ! using GC isoprene data where available, otherwise probed MRs
       if ( ci.eq.idx_isop ) then
       ! isoprene
         where ( lGCisop(1:smpQ) .ge. 0. )
           isop(1:smpQ) = lGCisop(1:smpQ)
         elsewhere
           isop(1:smpQ) = comp(ci)%mr
         endwhere
       ! calculate sample-wise
         do si = 1, smpQ
           gsc(comp(ci)%fsi(:),si) = gsc(comp(ci)%fsi(:),si) + isop(si)*comp(ci)%fy(:)
         enddo
       else
       ! other compound, calculate sample-wise
         do si = 1, smpQ
           gsc(comp(ci)%fsi(:),si) = gsc(comp(ci)%fsi(:),si) + comp(ci)%mr*comp(ci)%fy(:)
         enddo
       endif
#else
     ! no GC isoprene data, copying pure random spectra to all samples' gen. data
       gsc(ci,1:smpQ) = gsc(ci,sTOFf_case_rand)
#endif
     enddo

   ! lumped mass and MR from all fragments
   ! pure random
     lump_cmr(sTOFf_case_rand) = sum(comp(:)%mr)
     lump_cm(sTOFf_case_rand)  = dot_product(comp(:)%mr,comp(:)%m)
     lump_fmr(sTOFf_case_rand) = sum(gsc(:,1+smpQ))
     lump_fm(sTOFf_case_rand)  = dot_product((gsm(:)-hymass),gsc(:,1+smpQ))     !> H+ is subtracted
#ifdef sTOFf_GC_isop_data
   ! with GC isoprene: subtracting random, adding GC
     do si = 1, smpQ
       lump_cmr(si) = lump_cmr(sTOFf_case_rand) + (-comp(idx_isop)%mr+isop(si))
       lump_cm(si)  = lump_cm(sTOFf_case_rand)  + (-comp(idx_isop)%mr+isop(si))*comp(idx_isop)%m
       lump_fmr(si) = sum(gsc(:,si))
       lump_fm(si)  = dot_product((gsm(:)-hymass),gsc(:,si))  !> H+ is subtracted
     enddo
#else
   ! no GC isoprene data, copying pure random masses to all samples
     lump_cmr(1:smpQ) = lump_cmr(sTOFf_case_rand)
     lump_cm(1:smpQ)  = lump_cm(sTOFf_case_rand)
     lump_fmr(1:smpQ) = lump_fmr(sTOFf_case_rand)
     lump_fm(1:smpQ)  = lump_fm(sTOFf_case_rand)
#endif

   ! normalised counts
     gscn(:,:) = 0.
     where ( l2gsmQ(:,:) .gt. 0 ) gscn(:,:) = gsc(:,:)   ! copy only counts on masses that are compared later
     do si = 1, smpQ+1
       if ( sum(gsc(:,si)) .gt. 0. ) gscn(:,si) = gsc(:,si)/maxval(gsc(:,si))
     enddo

   ! calculate gen. vs. lab. counts correlation [k+b+R2+5interm,1:smpQ] | ref. http://www.pgccphy.net/Linreg/linreg_f90.txt
     corr(:,:) = 0.
     do si = 1, smpQ
     ! avoid division by zero
       if ( ( sum(l2gsmQ(:,si)) .eq. 0 ) .or. ( sum(l2gsc(:,si)) .eq. 0 ) ) cycle
       do mi = 1, gsmQ
         if ( l2gsmQ(mi,si) .gt. 0 ) then
         ! sumg, sumg2
           corr(4,si) = corr(4,si) + gsc(mi,si)
           corr(5,si) = corr(5,si) + gsc(mi,si)**2
         ! sumgl
           corr(6,si) = corr(6,si) + gsc(mi,si)*l2gsc(mi,si)
         ! suml, suml2
           corr(7,si) = corr(7,si) + l2gsc(mi,si)
           corr(8,si) = corr(8,si) + l2gsc(mi,si)**2
         endif
       enddo
     ! slope
       corr(1,si) = (l2gsmQC(si)*corr(6,si)-corr(4,si)*corr(7,si)) / &
                    (l2gsmQC(si)*corr(5,si)-corr(4,si)**2)
     ! bias
       corr(2,si) = (corr(7,si)*corr(5,si)-corr(4,si)*corr(6,si)) / &
                    (l2gsmQC(si)*corr(5,si)-corr(4,si)**2)
     ! R-squared
       corr(3,si) = (corr(6,si)-corr(4,si)*corr(7,si)/l2gsmQC(si)) / &
                    sqrt((corr(5,si)-corr(4,si)**2/l2gsmQC(si))*(corr(8,si)-corr(7,si)**2/l2gsmQC(si)))
     enddo

#ifdef DEBUG
     print *, '-----------------------------------------------------------------'
     print '(A,*(f7.2))',   '  masses:',gsm(:)
     print *, '- pure random ---------------------------------------------------'
     print *, 'lump fmr / fm:',lump_fmr(1+smpQ), lump_fm(1+smpQ)
     print '(A,*(e7.1E1))', 'gen.cnt.:',gsc(:,1+smpQ)
     print '(A,*(f7.1))',   '(%norm.):',gscn(:,1+smpQ)*1e2
   do si = 1, smpQ
     print *, '- '//num2str(si,fmt=fmt_smp)//'----------------------------------------------'
     print *, 'lump fmr / fm:',lump_fmr(si), lump_fm(si)
     print '(A,*(e7.1E1))', 'gen.cnt.:',gsc(:,si)
     print '(A,*(f7.1))',   '(%norm.):',gscn(:,si)*1e2
     print '(A,*(e7.1E1))', 'lab.cnt.:',l2gsc(:,si)
     print '(A,*(f7.1))',   '(%norm.):',l2gscn(:,si)*1e2
   enddo
#endif

     aMC_shot_done = .true.
     aMC_shot_real = .true.
#endif /* aMC__physc__code */
! ----- aMC_physc:check_req_hits -----
! inside the loop over cases: cn = aMC_match_case_from, aMC_match_case_upto
#ifdef    aMC__physc__check_req_hits__code
        ! stop when hit statistic is complete for all samples in sets to fill up
          do sn = aMC_match_set_from, aMC_match_set_upto
            if ( aMC_hit_set(cn)%fill .and. ( aMC_hits(cn,sn,00).lt.aMC_req_hits ) ) then
              req_hits_found4all = .false.
              exit ! do-loop
            endif
          enddo
#ifdef DEBUG
        ! stop after aMC_req_hits
          req_hits_found4all = (aMC_tries.gt.aMC_req_hits)
          req_hits_found4all = (aMC_tries.gt.3)
#endif
#endif /* aMC__physc__check_req_hits__code */

! ----- info output ------------------------------------------------------------
#ifdef    aMC__info__code
    _info_ '| - spectra mass resolution factor (smrf=m/dm): 1/'//num2str(r=1./sTOFf_smrf,fmt='(F0.1)')
    _info_ '| - fit tolerance (absolute): '//num2str(r=fatol,fmt='(e10.3E2)')//' mol/mol'
    _info_ '| - fit tolerance (relative): '//num2str(r=frtol,fmt='(e10.3E2)')
#ifdef sTOFf_GC_isop_data
    _info_ '| + using GC isoprene lab data'
#endif
#ifdef sTOFf_output_fragment_yields
    _info_ '| + include fragment yields in the output'
#endif
#ifdef sTOFf_output_lab2gen_spectra
    _info_ '| + include lab spectra intgrated to generated masses in the output'
#endif
    if ( sTOFf_ucompQ .gt. 0 ) &
      _info_ '| + add unknown compounds ('//num2str(sTOFf_ucompQ)//', max. probed MR: '//num2str(r=sTOFf_ucomp_mr_maxprobe)//' ppb)'
#ifdef sTOFf_output_dot          /* produce diagram of compounts -> fragments -> masses links */
    _info_ '| + produce compound-fragment-masses diagram in graphviz .dot format'
#endif
#ifdef sTOFf_strange_sets
    _info_ '| + enable strange hit sets'
#endif
#endif /* aMC__info__code */

! --- XXX ---
#ifdef    aMC__XXX__defs
#endif /* aMC__XXX__defs */
#ifdef    aMC__XXX__code
#endif /* aMC__XXX__code */
